function CMenu(){
    var _pStartPosAudio = null;
    var _pStartPosLogo;
	var _pStartPosLogoHorizontal;
    var _pStartPosLogoVertical;
    
    var _oBg;
    var _oButPlay;
	var _oLogoHorizontal;
    var _oLogoVertical;
    var _oLogo;
    var _oFade;
    var _oAudioToggle;
    
    this._init = function(){
        _pStartPosLogo = {x:20,y:20};
        
        _oBg = new createBitmap(s_oSpriteLibrary.getSprite('bg_menu'));
        s_oStage.addChild(_oBg);
        
        _oLogo = new createBitmap(s_oSpriteLibrary.getSprite('logo'));
        _oLogo.x = _pStartPosLogo.x;
        _oLogo.y = _pStartPosLogo.y; 
        s_oStage.addChild(_oLogo);

        var oSprite = s_oSpriteLibrary.getSprite('but_start');
        _oButPlay = new CGfxButton((CANVAS_WIDTH/2),CANVAS_HEIGHT/2 - 90,oSprite,s_oStage);
        _oButPlay.addEventListener(ON_MOUSE_UP, this._onButPlayRelease, this);
		
		
        if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){
            var oSprite = s_oSpriteLibrary.getSprite('audio_icon');
            _pStartPosAudio = {x: CANVAS_WIDTH - (oSprite.height/2)- 10, y: (oSprite.height/2) + 10};   
            _oAudioToggle = new CToggle(_pStartPosAudio.x,_pStartPosAudio.y,oSprite,s_bAudioActive,true);
            _oAudioToggle.addEventListener(ON_MOUSE_UP, this._onAudioToggle, this);
			
            if(s_oSoundTrack === null){
                    s_oSoundTrack = createjs.Sound.play("soundtrack",{ loop:-1,volume:SOUNDTRACK_VOLUME});
                    
            }else{
                s_oSoundTrack.volume = 1;
            }
			 
        }
		
		if ( CloudAPI.links.active()) {
            this._initLogo();
        }
		
        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("black").drawRect(0,0,CANVAS_WIDTH,CANVAS_HEIGHT);
        
        s_oStage.addChild(_oFade);
        
        createjs.Tween.get(_oFade).to({alpha:0}, 1000).call(function(){_oFade.visible = false;});  
        
        if(s_bMobile === false){
            document.onkeydown   = onKeyDown; 
        }
        
        this.refreshButtonPos(s_iOffsetX,s_iOffsetY);
    };
    
    this.unload = function(){
        _oButPlay.unload(); 
        _oButPlay = null;
        
        if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){
            _oAudioToggle.unload();
            _oAudioToggle = null;
        }
        
		if ( CloudAPI.links.active()) {
           _oLogoHorizontal.off("click",function(){s_oMenu._onLogoClicked});
           _oLogoVertical.off("click",function(){s_oMenu._onLogoClicked});
        }
		
        s_oStage.removeAllChildren();
    };
    
    this.refreshButtonPos = function(iNewX,iNewY){
        if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){
            _oAudioToggle.setPosition(_pStartPosAudio.x - iNewX,iNewY + _pStartPosAudio.y);
        }   
        
		if ( CloudAPI.links.active()) {
            _oLogoHorizontal.x = _pStartPosLogoHorizontal.x + iNewX;
            _oLogoHorizontal.y = _pStartPosLogoHorizontal.y - iNewY;
            _oLogoVertical.x = _pStartPosLogoVertical.x - iNewX;
            _oLogoVertical.y = _pStartPosLogoVertical.y + iNewY;
        }
		
        _oLogo.x = _pStartPosLogo.x + iNewX;
        _oLogo.y = _pStartPosLogo.y + iNewY;
    };
	
	this._initLogo = function(){
        var oList = CloudAPI.logos.list();
        var szLogoUrl = oList.horizontal;
        _pStartPosLogoHorizontal = {x:10,y:CANVAS_HEIGHT - 140};

        _oLogoHorizontal = new createjs.Bitmap(szLogoUrl);
        _oLogoHorizontal.x = _pStartPosLogoHorizontal.x;
        _oLogoHorizontal.y = _pStartPosLogoHorizontal.y;
		_oLogoHorizontal.visible = false;
        s_oStage.addChild(_oLogoHorizontal);

        szLogoUrl = oList.vertical;
		
		if(_pStartPosAudio === null){
			_pStartPosLogoVertical = {x:CANVAS_WIDTH - 240,y: 8};
		}else{
			_pStartPosLogoVertical = {x:_pStartPosAudio.x - 240,y: 8};
		}
        
        _oLogoVertical = new createjs.Bitmap(szLogoUrl);
        _oLogoVertical.x = _pStartPosLogoVertical.x;
        _oLogoVertical.y = _pStartPosLogoVertical.y;
		_oLogoVertical.visible = false;
        s_oStage.addChild(_oLogoVertical); 

        setTimeout(function(){s_oMenu.createHitAreaForLogo();},1000);
    };
    
    this.createHitAreaForLogo = function(){
        var hitObject = new createjs.Shape();
        hitObject.graphics.beginFill("#ff0").drawRect(0, 0, Math.floor(_oLogoHorizontal.image.width), Math.floor(_oLogoHorizontal.image.height));
        _oLogoHorizontal.hitArea = hitObject;
        _oLogoHorizontal.scaleX = _oLogoHorizontal.scaleY = 0.6;
		_oLogoHorizontal.shadow = new createjs.Shadow("#000000", 2, 2, 3);
        _oLogoHorizontal.on("pressup", this._onLogoClicked);
		_oLogoHorizontal.visible = true;
         

         var hitObject = new createjs.Shape();
        hitObject.graphics.beginFill("#ff0").drawRect(0, 0, Math.floor(_oLogoVertical.image.width), Math.floor(_oLogoVertical.image.height));
        _oLogoVertical.hitArea = hitObject;
        _oLogoVertical.scaleX = _oLogoVertical.scaleY = 0.22;
		_oLogoVertical.shadow = new createjs.Shadow("#000000", 2, 2, 3);
        _oLogoVertical.on("pressup", this._onButMoreGames);
        _oLogoVertical.visible = true;
    };
    
    this._onAudioToggle = function(){
        createjs.Sound.setMute(s_bAudioActive);
        s_bAudioActive = !s_bAudioActive;
    };
    
    function onKeyDown(evt) { 
        if(!evt){ 
            evt = window.event; 
        }  

        switch(evt.keyCode) {  
           // spacebar  
           case 32: {
                   s_oMenu.unload();
                   s_oMain.gotoGame();
                   break; 
               }
        }  
    }
    
    this._onButPlayRelease = function(){
        s_oMenu.unload();
        s_oMenu = null;
        s_oMain.gotoGame();
    };
	
	this._onButMoreGames = function(){
        if ( CloudAPI.links.active()) {
            window.open ( CloudAPI.links.list()['games']);
        };
    };
    
    this._onLogoClicked = function(){
        if ( CloudAPI.links.active( )) {
            window.open ( CloudAPI.links.list()['logo']);
        }
    };
	
    s_oMenu = this;
        
    this._init();
}

var s_oMenu = null;